<?php

declare(strict_types=1);

namespace App\Repository;

final class TblRolRepository
{
    private \PDO $database;

    public function __construct(\PDO $database)
    {
        $this->database = $database;
    }

    public function getDb(): \PDO
    {
        return $this->database;
    }

    public function checkAndGet(int $TblRolId): object
    {
        $query = 'SELECT * FROM `TblRol` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblRolId);
        $statement->execute();
        $TblRol = $statement->fetchObject();
        if (! $TblRol) {
            throw new \Exception('TblRol not found.', 404);
        }

        return $TblRol;
    }

    public function getAll(): array
    {
        $query = 'SELECT * FROM `TblRol` ORDER BY `id`';
        $statement = $this->getDb()->prepare($query);
        $statement->execute();

        return (array) $statement->fetchAll();
    }

    public function create(object $TblRol): object
    {
        $query = 'INSERT INTO `TblRol` (`Nombre`, `field1`, `field2`, `field3`, `field4`, `field5`) VALUES (:Nombre, :field1, :field2, :field3, :field4, :field5)';
        $statement = $this->getDb()->prepare($query);
//         $statement->bindParam('id', $TblRol->id);
//         $statement->bindParam('fecha', $TblRol->fecha);
        $statement->bindParam('Nombre', $TblRol->Nombre);
        $statement->bindParam('field1', $TblRol->field1);
        $statement->bindParam('field2', $TblRol->field2);
        $statement->bindParam('field3', $TblRol->field3);
        $statement->bindParam('field4', $TblRol->field4);
        $statement->bindParam('field5', $TblRol->field5);

        $statement->execute();

        return $this->checkAndGet((int) $this->getDb()->lastInsertId());
    }

    public function update(object $TblRol, object $data): object
    {
        if (isset($data->fecha)) {
            $TblRol->fecha = $data->fecha;
        }
        if (isset($data->Nombre)) {
            $TblRol->Nombre = $data->Nombre;
        }
        if (isset($data->field1)) {
            $TblRol->field1 = $data->field1;
        }
        if (isset($data->field2)) {
            $TblRol->field2 = $data->field2;
        }
        if (isset($data->field3)) {
            $TblRol->field3 = $data->field3;
        }
        if (isset($data->field4)) {
            $TblRol->field4 = $data->field4;
        }
        if (isset($data->field5)) {
            $TblRol->field5 = $data->field5;
        }

        $query = 'UPDATE `TblRol` SET `fecha` = :fecha, `Nombre` = :Nombre, `field1` = :field1, `field2` = :field2, `field3` = :field3, `field4` = :field4, `field5` = :field5 WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblRol->id);
        $statement->bindParam('fecha', $TblRol->fecha);
        $statement->bindParam('Nombre', $TblRol->Nombre);
        $statement->bindParam('field1', $TblRol->field1);
        $statement->bindParam('field2', $TblRol->field2);
        $statement->bindParam('field3', $TblRol->field3);
        $statement->bindParam('field4', $TblRol->field4);
        $statement->bindParam('field5', $TblRol->field5);

        $statement->execute();

        return $this->checkAndGet((int) $TblRol->id);
    }

    public function delete(int $TblRolId): void
    {
        $query = 'DELETE FROM `TblRol` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblRolId);
        $statement->execute();
    }
}
